/*  
  AboutDlg.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/

package gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import logic.*;

public class AboutDlg extends JDialog {
  JPanel insetsPanel1 = new JPanel();
  String product   = "TimeToaster";
  String version   = "Version 1.0 ";
  String copyright = "Copyright (c)2001";
  String comments  = "SoPra Gruppe 14";
  FlowLayout flowLayout1 = new FlowLayout();
  JPanel insetsPanel3 = new JPanel();
  JLabel label4 = new JLabel();
  JLabel label3 = new JLabel();
  JLabel label2 = new JLabel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel label1 = new JLabel();
  JLabel imageLabel = new JLabel();
  JPanel insetsPanel2 = new JPanel();
  JButton jButton_OK = new JButton();

  public AboutDlg(JComponent parent) {
    super((Frame)parent.getTopLevelAncestor(), "Info", true);
    try {
      jbInit();
      pack();
      setLocationRelativeTo(parent);
      getRootPane().setDefaultButton(jButton_OK);
    }
    catch(Exception e) {
      e.printStackTrace();
    }

    pack();
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {

    String path = System.getProperty("user.dir") + System.getProperty("file.separator");
    imageLabel.setIcon(new ImageIcon( path + "toaster.gif" ));

    setResizable(false);
    this.setModal(true);
    insetsPanel1.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.RIGHT);
    insetsPanel3.setLayout(gridBagLayout1);
    insetsPanel3.setBorder(BorderFactory.createEmptyBorder(10, 60, 10, 10));
    label4.setAlignmentX((float) 0.5);
    label4.setText(comments);
    label3.setAlignmentX((float) 0.5);
    label3.setText(copyright);
    label2.setAlignmentX((float) 0.5);
    label2.setText("Version 1.0");
    label1.setFont(new java.awt.Font("Dialog", 1, 24));
    label1.setForeground(Color.darkGray);
    label1.setAlignmentX((float) 0.5);
    label1.setText("TimeToaster");
    imageLabel.setAlignmentX((float) 0.5);
    imageLabel.setIconTextGap(0);
    insetsPanel2.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    jButton_OK.setActionCommand("OK");
    jButton_OK.setMnemonic('0');
    jButton_OK.setText("OK");

    jButton_OK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_OK_actionPerformed(e);
      }
    });

    this.getContentPane().add(insetsPanel1, BorderLayout.SOUTH);
    insetsPanel1.add(jButton_OK, null);
    this.getContentPane().add(insetsPanel3, BorderLayout.CENTER);
    insetsPanel3.add(label1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 16, 0), 0, 0));
    insetsPanel3.add(label2, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    insetsPanel3.add(label3, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    insetsPanel3.add(label4, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 8, 8), 0, 0));
    this.getContentPane().add(insetsPanel2, BorderLayout.WEST);
    insetsPanel2.add(imageLabel, null);
  }


 /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  /**Close the dialog*/
  void cancel() {
    dispose();
  }

  void jButton_OK_actionPerformed(ActionEvent e) {
    cancel();
  }


}

