/*  
  AufgabenDlg.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/


package gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import logic.*;

public class AufgabenDlg extends JDialog {
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JButton jButton_OK = new JButton();
  JButton jButton_Abbrechen = new JButton();
  FlowLayout flowLayout1 = new FlowLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JTextField jTextField_Personen = new WholeNumberField();
  JTextField jTextField_Dauer = new WholeNumberField();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JTextField jTextField_Name = new JTextField();

  /**
   *  Das Aufgabenobjekt, mit dem dieser Dialog arbeitet
   */
  Aufgabe  aufgabe;
  boolean  userClickedOK = false;


  public AufgabenDlg(JComponent parent, Aufgabe aufgabe)
  {
    super((Frame)parent.getTopLevelAncestor(), "Aufgabendetails");
    jbInit();
    pack();
    setLocationRelativeTo(parent);
    getRootPane().setDefaultButton(jButton_OK);

    this.aufgabe = aufgabe;
    jTextField_Name.setText(aufgabe.getName());
    jTextField_Dauer.setText(Integer.toString(aufgabe.getDauer()));
    jTextField_Personen.setText(Integer.toString(aufgabe.getPersonenZahl()));
  }

  void jbInit()  {
    panel1.setLayout(borderLayout1);
    jButton_OK.setMnemonic('0');
    jButton_OK.setText("OK");
    jButton_OK.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton_OK_actionPerformed(e);
      }
    });
    jButton_Abbrechen.setMnemonic('0');
    jButton_Abbrechen.setText("Abbrechen");
    jButton_Abbrechen.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton_Abbrechen_actionPerformed(e);
      }
    });
    jPanel2.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.RIGHT);
    jPanel1.setLayout(gridBagLayout1);
    jLabel1.setDisplayedMnemonic('N');
    jLabel1.setLabelFor(jTextField_Name);
    jLabel1.setText("Name");
    jLabel2.setDisplayedMnemonic('P');
    jLabel2.setLabelFor(jTextField_Personen);
    jLabel2.setText("Personenanzahl");
    jLabel3.setDisplayedMnemonic('D');
    jLabel3.setLabelFor(jTextField_Dauer);
    jLabel3.setText("Dauer");
    jTextField_Personen.setColumns(5);
    jTextField_Dauer.setColumns(5);
    this.setResizable(false);
    this.setModal(true);
    getContentPane().add(panel1);
    panel1.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jTextField_Name, new GridBagConstraints(1, 0, 4, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 8, 8), 0, 0));
    jPanel1.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(10, 8, 16, 8), 0, 0));
    jPanel1.add(jLabel2, new GridBagConstraints(0, 1, 2, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(2, 8, 8, 8), 0, 0));
    jPanel1.add(jLabel3, new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(2, 8, 8, 8), 0, 0));
    jPanel1.add(jTextField_Personen, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 8, 8), 0, 0));
    jPanel1.add(jTextField_Dauer, new GridBagConstraints(4, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 8, 8), 0, 0));
    panel1.add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(jButton_OK, null);
    jPanel2.add(jButton_Abbrechen, null);
  }

  public boolean userClickedOK() {
    return userClickedOK;
  }

  void jButton_OK_actionPerformed(ActionEvent e) {
    aufgabe.setName( jTextField_Name.getText() );
    aufgabe.setDauer( Integer.parseInt( jTextField_Dauer.getText() ));
    aufgabe.setPersonenZahl( Integer.parseInt(jTextField_Personen.getText() ));
    userClickedOK = true;
    dispose();
  }

  void jButton_Abbrechen_actionPerformed(ActionEvent e) {
   userClickedOK = false;
   dispose();
  }
}
