/*  
  BenutzerPanel.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/

package gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;
import logic.*;


public class BenutzerPanel extends JPanel implements StatusConst {
  JSplitPane jSplitPane1 = new JSplitPane();
  JButton jButton_NEntfernen = new JButton();
  JButton jButton_NAendern = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  JButton jButton_NNeu = new JButton();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JButton jButton_IncWoche = new JButton();
  JButton jButton_TAendern = new JButton();
  JScrollPane jScrollPane2 = new JScrollPane();
  FlowLayout flowLayout3 = new FlowLayout();
  FlowLayout flowLayout2 = new FlowLayout();
  FlowLayout flowLayout4 = new FlowLayout();
  JButton jButton_DecWoche = new JButton();
  JLabel jLabel_Woche = new JLabel();
  JPanel jPanel5 = new JPanel();
  JPanel jPanel4 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel6 = new JPanel();
  JPanel jPanel7 = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  BorderLayout borderLayout4 = new BorderLayout();
  JLabel jLabel1 = new JLabel();
  JTable jTable_Termine = new JTable();
  DefaultListModel nutzerListModel = new DefaultListModel();
  BorderLayout borderLayout1 = new BorderLayout();
  FlowLayout flowLayout1 = new FlowLayout();
  JList jList_Nutzer = new JList();
  DefaultTableModel  terminModel;

  /**
   *  Diese Ansicht braucht Zugriff auf die Nutzerverwaltung
   */
  private Nutzerverwaltung  nutzerVerwaltung;
  private Projekt projekt;
  private Nutzer  selectedNutzer;
  private int     anzeigeWoche = 1;

  public BenutzerPanel( Projekt projekt ) {
    nutzerVerwaltung = projekt.getNutzerverwaltung();
    this.projekt = projekt;
    jbInit();
    updateBenutzerListe();
    updateTerminPlan();
  }

  void jbInit() {
    jSplitPane1.setOneTouchExpandable(true);
    jButton_NEntfernen.setMnemonic('E');
    jButton_NEntfernen.setText("Entf.");
    jButton_NEntfernen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_NEntfernen_actionPerformed(e);
      }
    });
    jButton_NAendern.setToolTipText("");
    jButton_NAendern.setMnemonic('R');
    jButton_NAendern.setText("ndern");
    jButton_NAendern.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_NAendern_actionPerformed(e);
      }
    });
    jButton_NNeu.setToolTipText("");
    jButton_NNeu.setMnemonic('N');
    jButton_NNeu.setText("Neu");
    jButton_NNeu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_NNeu_actionPerformed(e);
      }
    });
    jPanel1.setLayout(flowLayout1);
    jPanel2.setLayout(borderLayout2);
    jButton_IncWoche.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton_IncWoche_actionPerformed(e);
      }
    });
    jButton_IncWoche.setText(">");
    jButton_IncWoche.setMnemonic('>');
    jButton_TAendern.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton_TAendern_actionPerformed(e);
      }
    });
    jButton_TAendern.setText("Termin ndern");
    jButton_TAendern.setMnemonic('T');
    flowLayout3.setAlignment(FlowLayout.RIGHT);
    flowLayout2.setAlignment(FlowLayout.LEFT);
    flowLayout4.setAlignment(FlowLayout.LEFT);
    jButton_DecWoche.setEnabled(false);
    jButton_DecWoche.setToolTipText("");
    jButton_DecWoche.setMnemonic('<');
    jButton_DecWoche.setText("<");
    jButton_DecWoche.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton_DecWoche_actionPerformed(e);
      }
    });
    jLabel_Woche.setText("Woche: 1");
    jPanel5.setLayout(borderLayout3);
    jPanel4.setLayout(flowLayout4);
    jPanel3.setLayout(flowLayout3);
    jPanel6.setLayout(flowLayout2);
    jPanel7.setLayout(borderLayout4);
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 24));
    jLabel1.setForeground(Color.darkGray);
    jLabel1.setText("Stundenplan");
    this.setLayout(borderLayout1);
    jList_Nutzer.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jList_Nutzer.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        jList_Nutzer_valueChanged(e);
      }
    });
    jList_Nutzer.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mouseClicked(MouseEvent e) {
        jList_Nutzer_mouseClicked(e);
      }
    });
    jList_Nutzer.setToolTipText("Doppelklicken fr Details");
    jList_Nutzer.setModel(nutzerListModel);
    jTable_Termine.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        jTable_Termine_mouseClicked(e);
      }
    });
    jScrollPane2.setToolTipText("Doppelklicken zum ndern");
    jTable_Termine.setFont(new java.awt.Font("Dialog", 0, 10));
    jTable_Termine.setRowHeight(32);
    jTable_Termine.setDefaultRenderer( TextAreaCell.class, new TextAreaRenderer() );
    this.add(jSplitPane1, BorderLayout.CENTER);
    jSplitPane1.add(jPanel2, JSplitPane.TOP);
    jPanel2.add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jButton_NNeu, null);
    jPanel1.add(jButton_NAendern, null);
    jPanel1.add(jButton_NEntfernen, null);
    jPanel2.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jList_Nutzer, null);
    jSplitPane1.add(jPanel5, JSplitPane.BOTTOM);
    jPanel5.add(jScrollPane2, BorderLayout.CENTER);
    jPanel5.add(jPanel6, BorderLayout.NORTH);
    jPanel6.add(jLabel1, null);
    jPanel5.add(jPanel7, BorderLayout.SOUTH);
    jPanel7.add(jPanel4, BorderLayout.WEST);
    jPanel4.add(jButton_DecWoche, null);
    jPanel4.add(jLabel_Woche, null);
    jPanel4.add(jButton_IncWoche, null);
    jPanel7.add(jPanel3, BorderLayout.CENTER);
    jPanel3.add(jButton_TAendern, null);
    jScrollPane2.getViewport().add(jTable_Termine, null);
    jTable_Termine.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  }


  void jButton_IncWoche_actionPerformed(ActionEvent e) {
    anzeigeWoche++;
    updateTerminPlan();
  }

  void jButton_DecWoche_actionPerformed(ActionEvent e) {
    if (anzeigeWoche > 1) {
      anzeigeWoche--;
      updateTerminPlan();
    }
  }

  void jButton_TAendern_actionPerformed(ActionEvent e)
  {
    int row = jTable_Termine.getSelectedRow();
    if (row == -1)
      return;

    Datum datum = new Datum((String)terminModel.getValueAt(row, 0));
    Stundenplan stdplan = selectedNutzer.getStundenplan();
    Termin termin = stdplan.getTermin(datum);

    if (termin == null)
      if (projekt.getCurrentNutzer().isAdmin())
        termin = new Termin();
      else
        return;

    boolean darfAendern = projekt.getCurrentNutzer().isAdmin() ;
    TerminDlg dlg = new TerminDlg( this, termin, projekt, darfAendern );
    dlg.show();

    if (dlg.userClickedOK())
      stdplan.addTermin(datum, termin);

    updateTerminPlan();
  }

  void jList_Nutzer_mouseClicked(MouseEvent e) {
    if (e.getClickCount() >= 2)
      jButton_NAendern_actionPerformed(null);
  }

  void jButton_NAendern_actionPerformed(ActionEvent e)
  {
    JDialog dlg;
    int index = jList_Nutzer.getSelectedIndex();
    if (index == -1)
      return;

    Nutzer nutzer = nutzerVerwaltung.getNutzerAt(index);

    boolean darfDatenAendern = false;
    boolean darfPWAendern = false;
    boolean altesPWNotwendig = true;

    if (projekt.getCurrentNutzer().isAdmin()) {
      darfDatenAendern = true;
      darfPWAendern    = true;
      altesPWNotwendig = false;
    }

    if (projekt.getCurrentNutzer() == nutzer) {
      altesPWNotwendig = true;
      darfPWAendern    = true;
    }

    dlg = new BenutzerDlg(this, nutzer, darfDatenAendern, darfPWAendern, altesPWNotwendig);
    dlg.show();

    updateBenutzerListe();
    jList_Nutzer.setSelectedIndex(index);
  }


  void jButton_NEntfernen_actionPerformed(ActionEvent e)
  {
    int index = jList_Nutzer.getSelectedIndex();
    if (index == -1)
      return;

    Nutzer nutzer = (Nutzer)nutzerVerwaltung.getNutzerAt(index);

    int ret = JOptionPane.showConfirmDialog( this, "Mchten sie den Benutzer \"" +
      nutzer.getVorname() + " " + nutzer.getName() + "\" wirklich entfernen?",
      "Benutzer entfernen", JOptionPane.YES_NO_OPTION
    );

    if (ret != JOptionPane.YES_OPTION)
      return;

    try {
      nutzerVerwaltung.remNutzer(nutzer.getLoginName());
      updateBenutzerListe();
      if (index > nutzerVerwaltung.getNutzerCount()-1)
        index = nutzerVerwaltung.getNutzerCount()-1;
      jList_Nutzer.setSelectedIndex(index);
    } catch (Exception ex) {
      JOptionPane.showMessageDialog(
        this, ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE
      );
    };
  }


  void jButton_NNeu_actionPerformed(ActionEvent e)
  {
    Nutzer neuerNutzer   = new Nutzer(nutzerVerwaltung);
    BenutzerDlg dlg = new BenutzerDlg(this, neuerNutzer, true, true, false);
    dlg.show();

    if (dlg.userClickedOK()) {
      nutzerVerwaltung.addNutzer(neuerNutzer);
      updateBenutzerListe();
      jList_Nutzer.setSelectedIndex(nutzerVerwaltung.getNutzerCount()-1);
    }
  }

  public void updateBenutzerListe()
  {
    nutzerListModel.clear();
    for (int i=0; i<nutzerVerwaltung.getNutzerCount(); i++) {
      Nutzer nutzer = nutzerVerwaltung.getNutzerAt(i);
      nutzerListModel.addElement( nutzer.getVorname() + " " +
        nutzer.getName() + (nutzer.isAdmin() ? " *" : ""));
    }
  }


  public void updateTerminPlan()
  {
    if (projekt.getCurrentNutzer().isAdmin()) {
      jButton_NEntfernen.setEnabled(true);
      jButton_NNeu.setEnabled(true);
    } else {
      jButton_NEntfernen.setEnabled(false);
      jButton_NNeu.setEnabled(false);
    }

    if (selectedNutzer == null) {
      jButton_IncWoche.setEnabled(false);
      jButton_DecWoche.setEnabled(false);
      jButton_TAendern.setEnabled(false);
      return;
    }

    jLabel1.setText("Stundenplan fr " +
      selectedNutzer.getVorname() + " " + selectedNutzer.getName()
    );

    jLabel_Woche.setText("Woche: " + anzeigeWoche);
    jButton_IncWoche.setEnabled(true);
    jButton_DecWoche.setEnabled(anzeigeWoche > 1);

    boolean darfAendern = false;
    if (selectedNutzer == projekt.getCurrentNutzer())
      darfAendern = true;
    if (projekt.getCurrentNutzer().isAdmin())
      darfAendern = true;

    jButton_TAendern.setEnabled( darfAendern );

    terminModel = new DefaultTableModel() {
      public boolean isCellEditable(int row, int col) {
        return false;
      }
      public Class getColumnClass(int c) {
        switch (c) {
          default:
          case 0: return String.class;
          case 1: return TextAreaCell.class;
          case 2: return Integer.class;
          case 3: return Boolean.class;
        }
      }
    };

    String columnNames[] = { "Datum", "Ttigkeit", "Dauer", "Status" };
    terminModel.setColumnIdentifiers( columnNames );

    Datum datum = new Datum(5*(anzeigeWoche-1)+1, false);
    Stundenplan stdplan = selectedNutzer.getStundenplan();

    for (int i=0; i<10; i++) {
      Object row[] = { datum.toString(), null, null, null };
      Termin termin = stdplan.getTermin(datum);
      if (termin != null) {
        row[1] = new TextAreaCell(
          termin.getAufgabe().getName() + "\n" + termin.getTaetigkeit()
        );
        row[2] = new Integer(termin.getDauer());
        row[3] = new Boolean(termin.getErledigt());
        switch (termin.getStatus()) {
          case StatusConst.VERZOEGERT:
            ((TextAreaCell)row[1]).setBackground(COLOR_VERZOEGERT); break;
          case StatusConst.GEPLANT:
            ((TextAreaCell)row[1]).setBackground(COLOR_GEPLANT);    break;
        }
      };
      terminModel.addRow( row );
      datum.next();
    }

    jTable_Termine.setModel(terminModel);
    jTable_Termine.getColumnModel().getColumn(0).setPreferredWidth( 20);
    jTable_Termine.getColumnModel().getColumn(1).setPreferredWidth(280);
    jTable_Termine.getColumnModel().getColumn(2).setPreferredWidth( 20);
    jTable_Termine.getColumnModel().getColumn(3).setPreferredWidth( 20);
  }


  void jTable_Termine_mouseClicked(MouseEvent e) {
    if (e.getClickCount() >= 2)
      System.out.println( "doubleclick!" );
  }


  void jList_Nutzer_valueChanged(ListSelectionEvent e)
  {
    if (e.getValueIsAdjusting())
      return;

    int row = jList_Nutzer.getSelectedIndex();
    if ( row >= 0 && row < nutzerVerwaltung.getNutzerCount())
      selectedNutzer = nutzerVerwaltung.getNutzerAt( row );
    else
      selectedNutzer = null;

    updateTerminPlan();
  }
}
