/*  
  HauptFenster.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/

package gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.util.Properties;
import java.awt.print.*;
import logic.*;
import TimeToaster;
import javax.swing.border.*;

public class HauptFenster extends JFrame {
  /** Properties Objekt fr die Druckfunktionen */
  Properties printprefs = new Properties();

  JPanel       contentPane;
    BorderLayout     borderLayout1   = new BorderLayout();

  JMenuBar     jMenuBar1 = new JMenuBar();
    JMenu        jMenu_Datei = new JMenu();
      JMenuItem    jMenuItem_Datei_Neu = new JMenuItem();
      JMenuItem    jMenuItem_Datei_Oeffnen = new JMenuItem();
      JMenuItem    jMenuItem_Datei_Speichern = new JMenuItem();
      JMenuItem    jMenuItem_Datei_SpeichernUnter = new JMenuItem();
      JMenuItem    jMenuItem_Datei_Drucken = new JMenuItem();
      JMenuItem    jMenuItem_Datei_Beenden = new JMenuItem();
    JMenu        jMenu_Hilfe = new JMenu();
      JMenuItem    jMenuItem_Hilfe = new JMenuItem();
      JMenuItem    jMenuItem_Hilfe_Info = new JMenuItem();
  JPanel jPanel4 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JTabbedPane jTabbedPane2 = new JTabbedPane();
  ButtonGroup buttonGroup_Ansicht = new ButtonGroup();
  Border border1;
  JPanel jPanel_Content = new JPanel();
  JToolBar jToolBar_Ansicht = new JToolBar();
  JToggleButton jToggleButton_Termine = new JToggleButton();
  JToggleButton jToggleButton_Benutzer = new JToggleButton();
  JToggleButton jToggleButton_Planung = new JToggleButton();
  BorderLayout borderLayout2 = new BorderLayout();
  JMenuItem jMenuItem_Einloggen = new JMenuItem();

  /**
   *  Das Hauptfenster mu auf einige Methoden des
   *  Projektes zugreifen knnen.
   */
  private Projekt  projekt;



  /**Construct the frame*/
  public HauptFenster( Projekt projekt ) {
    this.projekt = projekt;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    jbInit();
    updateGUI();
  }

  /**Component initialization*/
  private void jbInit() {
    border1 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    setSize(new Dimension(700, 500));
    setTitle("TimeToaster");

    contentPane = (JPanel)this.getContentPane();
    contentPane.setLayout(borderLayout1);

    /* Datei Menu */
    jMenu_Datei.setText("Datei");
    jMenu_Datei.setActionCommand("Datei");
    jMenu_Datei.setMnemonic('D');
    jMenu_Datei.addSeparator();
    jMenuItem_Hilfe.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_Hilfe_actionPerformed(e);
      }
    });
    jMenu_Hilfe.setMnemonic('?');
    jMenuItem_Hilfe_Info.setMnemonic('O');
    jMenuItem_Hilfe.setMnemonic('H');
    jMenuItem_Datei_Neu.setMnemonic('N');
    jMenuItem_Datei_Oeffnen.setMnemonic('F');
    jMenuItem_Datei_SpeichernUnter.setMnemonic('U');
    jMenuItem_Datei_Speichern.setMnemonic('S');
    jMenuItem_Datei_Drucken.setMnemonic('D');
    jMenuItem_Datei_Beenden.setMnemonic('B');
    jToggleButton_Termine.setText("Termine");
    jToggleButton_Termine.setToolTipText("Terminbersicht");
    jToggleButton_Termine.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jToggleButton_Termine_actionPerformed(e);
      }
    });
    jToggleButton_Benutzer.setText("Benutzer");
    jToggleButton_Benutzer.setToolTipText("Benutzer und Stundenplne");
    jToggleButton_Benutzer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jToggleButton_Benutzer_actionPerformed(e);
      }
    });
    jToggleButton_Planung.setText("Planung");
    jToggleButton_Planung.setToolTipText("Planung und Berichte");
    jToggleButton_Planung.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jToggleButton_Planung_actionPerformed(e);
      }
    });
    jPanel_Content.setLayout(borderLayout2);
    jMenuItem_Einloggen.setMnemonic('E');
    jMenuItem_Einloggen.setText("Neu einloggen");
    jMenuItem_Einloggen.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jMenuItem_Einloggen_actionPerformed(e);
      }
    });
    jMenu_Datei.add(jMenuItem_Datei_Neu);
    jMenu_Datei.add(jMenuItem_Datei_Oeffnen);
    jMenu_Datei.add(jMenuItem_Einloggen);
    jMenu_Datei.addSeparator();
    jMenu_Datei.add(jMenuItem_Datei_Speichern);
    jMenu_Datei.add(jMenuItem_Datei_SpeichernUnter);
    jMenu_Datei.addSeparator();
    jMenu_Datei.add(jMenuItem_Datei_Drucken);
    jMenu_Datei.addSeparator();
    jMenu_Datei.add(jMenuItem_Datei_Beenden);

    /* Datei|Neu */
    jMenuItem_Datei_Neu.setActionCommand("Datei|Neu...");
    jMenuItem_Datei_Neu.setText("Neu...");
    jMenuItem_Datei_Neu.setAccelerator(javax.swing.KeyStroke.getKeyStroke(78, java.awt.event.KeyEvent.CTRL_MASK, false));
    jMenuItem_Datei_Neu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_Datei_Neu_actionPerformed(e);
      }
    });

    /* Datei|ffnen */
    jMenuItem_Datei_Oeffnen.setActionCommand("Datei|ffnen...");
    jMenuItem_Datei_Oeffnen.setText("ffnen...");
    jMenuItem_Datei_Oeffnen.setAccelerator(javax.swing.KeyStroke.getKeyStroke(79, java.awt.event.KeyEvent.CTRL_MASK, false));
    jMenuItem_Datei_Oeffnen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_Datei_Oeffnen_actionPerformed(e);
      }
    });

    /* Datei|Speichern */
    jMenuItem_Datei_Speichern.setActionCommand("Datei|Speichern");
    jMenuItem_Datei_Speichern.setText("Speichern");
    jMenuItem_Datei_Speichern.setAccelerator(javax.swing.KeyStroke.getKeyStroke(83, java.awt.event.KeyEvent.CTRL_MASK, false));
    jMenuItem_Datei_Speichern.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_Datei_Speichern_actionPerformed(e);
      }
    });

    /* Datei|Speichern unter... */
    jMenuItem_Datei_SpeichernUnter.setActionCommand("Datei|Speichern unter...");
    jMenuItem_Datei_SpeichernUnter.setText("Speichern unter...");
    jMenuItem_Datei_SpeichernUnter.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_Datei_SpeichernUnter_actionPerformed(e);
      }
    });

    /* Datei|Seite Einrichten... */

    /* Datei|Drucken... */
    jMenuItem_Datei_Drucken.setActionCommand("Datei|Drucken...");
    jMenuItem_Datei_Drucken.setText("Drucken...");
    jMenuItem_Datei_Drucken.setAccelerator(javax.swing.KeyStroke.getKeyStroke(80, java.awt.event.KeyEvent.CTRL_MASK, false));
    jMenuItem_Datei_Drucken.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_Datei_Drucken_actionPerformed(e);
      }
    });

    /* Datei|Beenden */
    jMenuItem_Datei_Beenden.setActionCommand("Datei|Beenden");
    jMenuItem_Datei_Beenden.setText("Beenden");
    jMenuItem_Datei_Beenden.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_Datei_Beenden_actionPerformed(e);
      }
    });

    /* Hilfe Menu */
    jMenu_Hilfe.setActionCommand("Hilfe");
    jMenu_Hilfe.setText("?");
    jMenu_Hilfe.addSeparator();
    jMenu_Hilfe.add(jMenuItem_Hilfe);
    jMenu_Hilfe.add(jMenuItem_Hilfe_Info);

    /* Hilfe|Hilfethemen */
    jMenuItem_Hilfe.setActionCommand("Hilfe|Hilfethemen");
    jMenuItem_Hilfe.setText("Hilfethemen");

    /* Hilfe|Info */
    jMenuItem_Hilfe_Info.setActionCommand("Hilfe|Info");
    jMenuItem_Hilfe_Info.setText("Info");
    jMenuItem_Hilfe_Info.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        jMenuItem_Hilfe_Info_actionPerformed(e);
      }
    });

    /* Menubar aufbauen */
    jMenuBar1.add(jMenu_Datei);
    jMenuBar1.add(jMenu_Hilfe);
    this.setJMenuBar(jMenuBar1);

    /* Tabbed Panes hinzufgen */
    contentPane.add(jPanel_Content, BorderLayout.CENTER);
    contentPane.add(jToolBar_Ansicht, BorderLayout.NORTH);
    jToolBar_Ansicht.add(jToggleButton_Benutzer, null);
    jToolBar_Ansicht.add(jToggleButton_Planung, null);
    jToolBar_Ansicht.add(jToggleButton_Termine, null);
    buttonGroup_Ansicht.add(jToggleButton_Benutzer);
    buttonGroup_Ansicht.add(jToggleButton_Planung);
    buttonGroup_Ansicht.add(jToggleButton_Termine);
  }

  /**
   *  Diese Methode wird ueberschrieben, damit das Programm nach
   *  dem Schliessen beendet wird.
   */
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      if (!actionBeenden(true))
        return;

    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      System.exit(0);
  }

  /**
   *  Datei | Neu... action performed
   *
   */
  void jMenuItem_Datei_Neu_actionPerformed(ActionEvent e)
  {
    actionNeu();
  }

  /**
   * Datei | Oeffnen... action performed
   */
  void jMenuItem_Datei_Oeffnen_actionPerformed(ActionEvent e)
  {
    actionOeffnen(true);
  }

  /**Datei | Speichern action performed*/
  void jMenuItem_Datei_Speichern_actionPerformed(ActionEvent e) {
    actionSpeichern();
  }

  /**Datei | SpeichernUnter... action performed*/
  void jMenuItem_Datei_SpeichernUnter_actionPerformed(ActionEvent e) {
    actionSpeichernUnter();
  }

  /**Datei | SeiteEinrichten action performed*/


  /**Datei | Drucken action performed*/
  void jMenuItem_Datei_Drucken_actionPerformed(ActionEvent e)
  {
    System.out.println(e.getActionCommand());
    try {
      Toolkit   toolkit = this.getToolkit();
      PrintJob  job = toolkit.getPrintJob( this, "TimeToaster", printprefs );
      if (job == null)
        return;

      Graphics  page = job.getGraphics();
      Dimension size = this.getSize();
      Dimension pagesize = job.getPageDimension();

      /* Auf seite Zentrieren */
      page.translate( (pagesize.width - size.width) / 2,
                      (pagesize.height - size.height) / 2 );

      /* Rahmen um die Ausgabe ziehen */
      page.drawRect( -1, -1, size.width-1, size.height- 1);
      page.setClip( 0, 0, size.width, size.height );
      this.printAll(page);

      page.dispose();
      job.end();
    }

    catch (Exception exception) {
      exception.printStackTrace();
      JOptionPane.showMessageDialog(
        this, exception, "Fehler beim Drucken", JOptionPane.ERROR_MESSAGE
      );
    }
  }

  /**Datei | Beenden action performed*/
  void jMenuItem_Datei_Beenden_actionPerformed(ActionEvent e) {
    if (actionBeenden(true))
      System.exit(0);
  }

  /**Hilfe | HilfeThemen action performed*/
  void jMenuItem_Hilfe_actionPerformed(ActionEvent e) {
    JDialog dlg = new HilfeDlg(getRootPane());
    dlg.show();
  }


  /**Hilfe | Info action performed*/
  public void jMenuItem_Hilfe_Info_actionPerformed(ActionEvent e)
  {
    JDialog dlg = new AboutDlg(getRootPane());
    dlg.show();
  }

  // --------------------------------------------------------------------------------
  //

  private boolean actionNeu() {

    int retval = JOptionPane.showConfirmDialog( this, "Mchten sie vorher speichern?" );
    switch (retval) {
      case JOptionPane.YES_OPTION:
        if (!actionSpeichern())
          return false;
        break;
      case JOptionPane.NO_OPTION:
        break;
      default:
        return false;
    }

    TimeToaster.projekt.neuesProjekt();
    updateGUI();
    return true;
  }

  boolean actionBeenden(boolean vorherSpeichern)
  {
    if (vorherSpeichern)
      if (!actionNeu())
        return false;

    System.exit(0);
    return true;
  }

  boolean actionSpeichern()
  {
    String filename = TimeToaster.projekt.getDateiname();

    if (filename == null) {
      JFileChooser chooser = new JFileChooser();
      int retval = chooser.showSaveDialog( this );
      if (retval != JFileChooser.APPROVE_OPTION)
        return false;

      filename = chooser.getSelectedFile().getPath();
    }

    try {
      TimeToaster.projekt.speichern( filename);
      return true;
    } catch (Exception ex) {
      JOptionPane.showMessageDialog( this,
        "Fehler beim Speichern!\n" + ex.getMessage(),
        "Fehler", JOptionPane.ERROR_MESSAGE
      );
      return false;
    }
  }

  boolean actionSpeichernUnter() {
    TimeToaster.projekt.setDateiname(null);
    return actionSpeichern();
  }

  boolean actionOeffnen( boolean vorherspeichern )
  {
    if (vorherspeichern)
      if (!actionNeu())
        return false;

    JFileChooser chooser = new JFileChooser();
    int retval = chooser.showOpenDialog(this);

    switch (retval) {
      case JFileChooser.APPROVE_OPTION:
        String filename = chooser.getSelectedFile().getPath();
        try {
          TimeToaster.projekt.laden(filename);
          break;
        } catch (Exception e) {
          JOptionPane.showMessageDialog( this,
            "Das Projekt konnte nicht geladen werden!\n" + e.getMessage(),
            "Fehler", JOptionPane.ERROR_MESSAGE
          );
          return false;
        }
      default:
        return false;
    }

    return actionEinloggen();
  }

  boolean actionEinloggen() {
    LoginDlg loginDlg = new LoginDlg( this.getRootPane(), projekt.getNutzerverwaltung(), projekt );
    loginDlg.show();

    if (loginDlg.userClickedOK()) {
      updateGUI();
      return true;
    } else {
      TimeToaster.projekt.neuesProjekt();
      updateGUI();
      return false;
    }
  }

  void jToggleButton_Benutzer_actionPerformed(ActionEvent e) {
    JPanel  benutzerPanel = new BenutzerPanel( projekt );
    jPanel_Content.removeAll();
    jPanel_Content.add( benutzerPanel, BorderLayout.CENTER);
    this.validate();
  }

  void jToggleButton_Planung_actionPerformed(ActionEvent e) {
    JPanel  planungsPanel = new PlanungsPanel( projekt );
    jPanel_Content.removeAll();
    jPanel_Content.add( planungsPanel, BorderLayout.CENTER);
    this.validate();
  }

  void jToggleButton_Termine_actionPerformed(ActionEvent e) {
    JPanel  terminPanel = new TerminPanel( projekt );
    jPanel_Content.removeAll();
    jPanel_Content.add(terminPanel, BorderLayout.CENTER);
    this.validate();
  }

  void updateGUI() {
    jToggleButton_Benutzer.setSelected(true);
    jToggleButton_Benutzer_actionPerformed(null);
  }

  void jMenuItem_Einloggen_actionPerformed(ActionEvent e) {
    actionEinloggen();
  }
}
